<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <script>
        // <!-- Реализовать класс Employee, в котором будут следующие свойства - name (имя), age (возраст), salary (зарплата). 
        //     Сделайте так, чтобы эти свойства заполнялись при создании объекта.
        // Создайте геттеры и сеттеры для этих свойств.
        // Создайте класс Programmer, который будет наследоваться от класса Employee, и у которого будет свойство lang (список языков).
        // Для класса Programmer перезапишите геттер для свойства salary. Пусть он возвращает свойство salary, умноженное на 3.
        // Создайте несколько экземпляров обьекта Programmer, выведите их в консоль. -->

        class Employee {
            constructor(name, age, salary) {
                this._name = name;
                this._age = age;
                this._salary = salary;
            }
            get personName() {
                return this._name;
            }
            set personName(value) {
                if (value.length == 0) {
                    alert('Имя не может быть пустым');
                    return;
                }
                this._name = value;
            }


            get personAge() {
                return this._age;
            }
            set personAge(value) {
                if (isNaN(value)) {
                    alert('Неправильный формат ввода данных о возрасте.Введите число');
                    return;
                }
                else if (value < 18 || value > 85) {
                    alert('Возрастная категория не соответствует');
                    return;
                }
                this._age = value;
            }


            get personSalary() {
                return this._salary;
            }
            set personSalary(value) {
                if (isNaN(value)) {
                    alert('Неправильный формат ввода данных о зарплате.Введите число ');
                    return;
                }
                else if (value < 0) {
                    alert('Зарплата сотрудника не может быть отрицательным числом');
                    return;
                }
                this._salary = value;
            }

        }
        const person1 = new Employee('Ivan', 25, 200);
        const person2 = new Employee('Olga', 20, 100);
        const person3 = new Employee('Peter', 32, 500);
        console.log(person1);
        console.log(person2);
        console.log(person3);
        person3.personName = "Mila";
        person3.personSalary = 4000;
        person3.personAge = 68;
        console.log(person3);
        console.log(person3.personName);
        // ---------------------------------------------------------------------------------------------------------------
        class Programmer extends Employee {
            constructor(name, age, salary, lang) {
                super(name, age, salary);
                this.language = lang;

            }
            get personSalary() {
                return this._salary = this._salary * 3;
            }
        }
        const programmer1 = new Programmer('Bobby', 24, 1000, 'english');
        const programmer2 = new Programmer('Anna', 29, 2200, 'ukr');
        const programmer3 = new Programmer('John', 35, 2000, 'russian');
        console.log(programmer1);
        console.log(programmer2);
        console.log(programmer3);
        console.log(programmer1.personSalary);
        console.log(programmer2.personSalary);
        console.log(programmer3.personSalary);

        programmer2.personAge = 45;
        programmer2.personName = 'Kat';
        programmer2.personSalary = 1300;
        console.log(programmer2);


    </script>
</body>

</html>